import javax.media.*;
import javax.media.protocol.*;

import java.sql.SQLException;
import java.util.*;
import java.io.*;

/*
 * Created on Feb 27, 2005
 *
 * 
 */

/**
 * @author popel
 *
 * Manages video audio over RTP connection using Java Media Frameword
 * 
 * */

public class MediaManager {
	public static final int MAX_DATASOURCE = 10;
	private final int START_PORT = 20000;
	private final int STOP_PORT  = 30000;
	//public String[]  mediaPosition = new String[MAX_DATASOURCE];
	//public String[] description = new String[MAX_DATASOURCE];
	//public String[] title = new String[MAX_DATASOURCE];
	public Vector mediaPosition = new Vector();
	public Vector description = new Vector();
	public Vector title = new Vector();
	
	private DataSource[] sources;
	
	//private DataSource[] sourceOriginal;
	private MediaLocator[] myLocator;
	private Stack portNumber;
	private int mediaCount;
	public int getAvailablePortNumber()
	{
		return ((Integer)portNumber.pop()).intValue();
		
	}
	public int getMediaCount()
	{
		return mediaCount;
	}
	public void addPort(int port)
	{
		portNumber.push(new Integer(port));
	}
	
	public DataSource getSource(int index)
	{
		if(index<0 || index>=MAX_DATASOURCE) return null;
		return ((SourceCloneable)sources[index]).createClone();
		//return sources[index];
		
	}
	private int readMediaPositions() throws SQLException
	{
		
		Vector v =DatabaseManager.dataMan.getMediaList();
		
		int len = v.size();
		
		MediaDescriptor md ;
		for(int i = 0;i<len;i++)
		{
			
			md  = (MediaDescriptor)v.get(i);
			//title[i] = md.type;
			title.add(md.type);
			//mediaPosition[i] = md.mediaLocator;
			mediaPosition.add(md.mediaLocator);
			//description[i] = md.description;
			description.add(md.description);
			
		}
		return len;
		
	}
	public void delMedia(int i)
	{
		title.removeElementAt(i);
		mediaPosition.removeElementAt(i);
		description.removeElementAt(i);
	}
	public void addMedia(String title1,String pos1,String desc1)
	{
		title.add(title1);
		mediaPosition.add(pos1);
		description.add(desc1);
	}
	public MediaManager() throws SQLException
	{
		// get the available media
		// make datasources which are cloneable
		sources = new DataSource[MAX_DATASOURCE];
		//sourceOriginal = new DataSource[MAX_DATASOURCE];
		myLocator = new MediaLocator[MAX_DATASOURCE];
		
		portNumber = new Stack();
		mediaCount = readMediaPositions();
		for(int i=0;i<Server.MAX_CONNECTION;i++)
			portNumber.push(new Integer(START_PORT+i*4));
		
	}
	public void setUpMedia()
	{
		try{
		for(int i=0;i<mediaCount;i++)
		{
			System.out.println("Creating Data Source for "+mediaPosition.get(i) );
			sources[i] = Manager.createDataSource(new MediaLocator((String)mediaPosition.get(i)));
			System.out.println("Data Source Created " + mediaPosition.get(i));
			sources[i]  =  Manager.createCloneableDataSource(sources[i]);
			
			
		}
		}
		catch(Exception e)
	{
		e.printStackTrace();
		System.err.println("Problems Creating Data Sources");
	}

	}
		
		
		
		
		
		
		
				
	}

