import java.io.IOException;
import java.net.*;
import javax.swing.*;
import java.util.*;

/**
 *This is the main server
 *It manages new clients, client commands, starts client threads
 *Manages video service to clients
 * *This class is the total "Client Manager" 
 * @author popel
 *

 */
public class Server implements Runnable
{
	public static final int MAX_CONNECTION = 100;
	public static final int BUET_VIDEO_SERVER_HANDSHAKE_PORT = 12345; 
	private ServerEventHandler  serverEventHandler;
	public MediaManager  myMediaManager  = null;
	private ServerSocket serverSocket;
	private Socket clients[] = new Socket[MAX_CONNECTION];
	private LogRecorder logServer;
	private String serverLogString; 
	//private ClientInfo clientList[] = new ClientInfo[MAX_CONNECTION];
	//private Stack userNumber = new Stack();
	
	private int counter  = 0 ;  //counts of connections (b4 authorization)
	private int authorizedCounter = 0; //counts of authorized clients
	/* (non-Javadoc)
	 * @see java.lang.Runnable#run()
	 */
	
	
	private void showError(String errMsg)
	{
		JOptionPane.showMessageDialog(null,errMsg);
		
	}
	
	public Server()
	{
		serverLogString = "_test";
		serverEventHandler = new ServerEventHandlerAdapter();
		
		//push user number into the stack
		// when a user authenticates he will be given a user id
		// when a user disconnects this id will be pushed to stack again
		
			
		
		
	}
	public void setServerEventHandler(ServerEventHandler x)
	{
		serverEventHandler = x;
		
	}
	
	private void doCleanUp()
	{
		serverSocket = null;
		logServer= null;
		
	}
	public void stopServer()
	{
		//close the log
		//TODO there is a problem which is to fix
		// TODO when the server stops, corresponding threads
		// TODO must also terminate, but here this does not happen
		try{
		
		serverSocket.close();
		logServer.close();
		
		
		// close the sockets
		
		
		}
		
		catch(IOException e)
		{
			e.printStackTrace();
			
		}
		
	}
	
	public void run()
	{
		try{
	
			runServer();
		}
		catch(IOException e)
		{
			System.err.println("Server Can't Start");
			e.printStackTrace();
		}
		finally{
			serverEventHandler.serverStops();
			
			stopServer();
			doCleanUp();
		}
		
	}
	
	public void setMediaManager(MediaManager m)
	{
		myMediaManager = m;
	}
	private void runServer() throws IOException
	{
		// Make the server listen to the port BUET_VIDEO_SERVER_HANDSHAKE_PORT
			
			serverSocket = new ServerSocket(Server.BUET_VIDEO_SERVER_HANDSHAKE_PORT,Server.MAX_CONNECTION);
			//server established now open its log
			System.out.println("Server Started Listening on port "+Server.BUET_VIDEO_SERVER_HANDSHAKE_PORT);
			logServer = new LogRecorder(LogRecorder.LOG_SERVER,serverLogString);
			//server ready
			
			serverEventHandler.serverStarts();
			logServer.addInfo("Server Started\n");

			
			
			
			while(true)
			{
				
				try{
					
					Socket socket  = listenForConnection();
					clientConnected();
					// a connection established, run a new thread of client handler ClientHandler
					
					int clientNumber = ClientList.onlyList. getNextUserNumber();
					clients[clientNumber] = socket;
					ClientHandler clientHandler = new ClientHandler(this,clients[clientNumber],clientNumber);
					clientHandler.setClientEventHandler(serverEventHandler);
					// start this thread. this will process this connection
					logServer.addInfo("New Client " + clients[clientNumber].getInetAddress().getHostAddress()+"\n");
					
					serverEventHandler.newClientConnected(clients[clientNumber].getInetAddress().getHostAddress());
					new Thread(clientHandler,"Client#"+clientNumber).start();
					
					// TODO here we are not keeping log about the client objects. they are inaccessible
					// TODO clients should be accessible from the server
					// TODO this is to be fixed 
					
					
									
				}
				catch (IOException e)
				{
					System.err.println("System Unable to connect");
					break; // this helps to stop the thread and the server
					
				}
				
			} //end while
		
		
		
		
	} //end method

	private Socket listenForConnection()throws IOException
	{
		Socket conn = new Socket();
		
		conn = serverSocket.accept(); // Server accepts connection	
		logServer.addInfo("New Connection from "+conn.getInetAddress().getHostAddress()+"\n");
		
		
		return conn;
		
	}
	public synchronized int getConnetionNumber()
	{
		return counter;
	}
	public synchronized void clientConnected()
	{
		//counts of connections (b4 authorization)
		
		counter++;
		
	}
	public synchronized void clientDisconnected(int number)
	{
		//counts of connections (b4 authorization)
		//ClientList.onlyList.reuseUserNumber(number);
		counter--;
		
		
	}
	public synchronized void clientAuthorized(int number )
	{
		// counts of authorized clients
		authorizedCounter++;
	}
	public synchronized void clientQuit()
	{
		//counts of authorized clients
		authorizedCounter--;
	}

	public void disconnectClient(int clientNumber)
	{
		if(clientNumber<0|| clientNumber>100 )return;
		try{
		if(clients[clientNumber]!=null)
		{
			clients[clientNumber].close();
			clients[clientNumber] = null;
			
		}
		}
		catch(Exception e)
		{
			e.printStackTrace();
		}
	}
} //end class