import java.awt.*;
import java.awt.event.*;
import java.util.Hashtable;
import java.util.Vector;
import java.sql.*;
import javax.media.CaptureDeviceInfo;
import javax.media.CaptureDeviceManager;
import javax.media.MediaLocator;
import javax.swing.*;

public class ServerInterface extends JFrame implements ServerEventHandler{
	private JTextField enterField;
	private JLabel lblHowMuchClients;
	private Server myVideoServer;
	private MediaManager myMediaManager;
	private int counter;
	private JTable tblClients;
	private JPanel midPanel,topPanel,leftPanel;
	private JLabel lblTitle;
	private JList filList;
	private JTextArea tLog;
	private JPanel pnlControl;
	private JLabel mPos  =new JLabel();
	private JTextField mDesc = new JTextField(10);
	private JTextField mTitle = new JTextField(10);
	private JButton btnDisconnect,btnPing,btnExit,btnStart,btnAddMedia,btnStop,btnMediaStart,btnAbout,btnHelp;
	private Thread serverThread;
	//private JButton btnServerTraffic,btnServerManagement,btnMediaManagement,btnClientManagement;
	
	private final String appTitle = "LAN TV Broadcasting Administration";
		

	private Vector vRow = new Vector();
	private Vector vCol = new Vector();
	private Vector v1 = new Vector();
	private Hashtable hashTable  = new Hashtable();
	private int tablePosition = 0;
	public ServerInterface(/*Server s*/) 
	{

		
		
		
		super("LAN TV");
		// myServer = s; 
		try{
			myMediaManager= new MediaManager();
			}
			catch(SQLException e)
			{
				e.printStackTrace();
				JOptionPane.showMessageDialog(this,"Can't Access Database for Media. System can't continue");
				System.exit(1);
				
			}
		
			
		Container container = getContentPane();
		
		container.setLayout(new BorderLayout());
		// the label attached at north
		
		lblTitle = new JLabel("LAN TV Broadcast Network");
		lblTitle.setFont(new Font("Times New Roman",10,20));
		
		
		lblTitle.setForeground(new Color(0,0,255));
		
		topPanel = new JPanel();
		
		topPanel.add(lblTitle);
		
		container.add(topPanel,BorderLayout.NORTH);
				
		// populate the table using user data from myServer
		
		vCol.addElement("User");
		vCol.addElement("IP");
		vCol.addElement("Current Activity");
		
		tblClients  = new JTable(vRow,vCol);
		
		lblHowMuchClients = new JLabel("0 Clients Connected");
		
		int v = ScrollPaneConstants.VERTICAL_SCROLLBAR_AS_NEEDED;
		int h = ScrollPaneConstants.HORIZONTAL_SCROLLBAR_AS_NEEDED;
		
	
		JScrollPane scroller = new JScrollPane(tblClients,v,h);
		
		
		// the JPanel attached at the south region
		pnlControl = new JPanel();
		
		midPanel = new JPanel();
		leftPanel = new JPanel();
		
		tLog = new JTextArea();
		
		tLog.setEditable(false);
		tLog.setBackground(Color.BLACK);
		tLog.setForeground(Color.WHITE);
		
		btnDisconnect = new JButton("Disconnect");
		btnPing = new JButton("Ping User");
		btnExit = new JButton("Exit");
		btnStart = new JButton("Start Server");
		btnStop = new JButton("Stop Server");
		btnMediaStart = new JButton("Start Media");
		btnAddMedia = new JButton("Add Media");
		btnAbout = new JButton("About this Program");
		btnHelp  = new JButton("Help");
		
		JPanel bottomPanel = new JPanel();
		
		bottomPanel.add(btnHelp);
		bottomPanel.add(btnAbout);
		bottomPanel.add(btnExit);
		midPanel.setLayout(new BorderLayout());
		leftPanel.setLayout(new BorderLayout());
		
		Icon serverManagement = new ImageIcon("serverManagement.png");
		pnlControl.add(new JLabel(serverManagement));
		pnlControl.add(btnStart);
		pnlControl.add(btnStop);
		
		
		pnlControl.add(btnAddMedia);
		pnlControl.add(btnMediaStart);
		
		JScrollPane scr1 = new JScrollPane(tLog);
		
		
		JPanel leftleftPanel = new JPanel();
		leftleftPanel.setLayout(new FlowLayout());;
		leftleftPanel.add(lblHowMuchClients);
		leftleftPanel.add(btnDisconnect);
		leftleftPanel.add(btnPing);
		
		leftPanel.add(scroller,BorderLayout.CENTER);
		leftPanel.add(leftleftPanel,BorderLayout.SOUTH);
		//midPanel.add(leftPanel);
		midPanel.add(scr1);
		
		Icon mediaManagement = new ImageIcon("mediaManagement.png");
		JPanel mediaPanel = new JPanel();
		mediaPanel.setLayout(new BorderLayout());
		
		// media Management tab;
		JPanel mediaLeft = new JPanel();
		JPanel mediaRight= new JPanel();
		
		mediaLeft.setLayout(new BorderLayout());
		mediaRight.setLayout(new BorderLayout());
		
		JLabel capDev = new JLabel("Capture Devices");
		capDev.setFont(new Font("Times New Roman",10,20));
		
		Object[] cList = CaptureDeviceManager.getDeviceList(null).toArray();
		MediaLocator ccList[] = new MediaLocator[cList.length];
		
		for(int i=0;i<cList.length;i++)
			ccList[i] = ((CaptureDeviceInfo)cList[i]).getLocator();
		
			
		JList capList  = new JList(ccList);
		
		mediaLeft.add(capDev,BorderLayout.NORTH);
		mediaLeft.add(capList,BorderLayout.CENTER);
		
		//mediaLeft.add(new JLabel(mediaManagement),BorderLayout.WEST);
		
		JLabel medLab = new JLabel("Media Files");
		medLab.setFont(new Font("Times New Roman",10,20));
		
		
		
		filList = new JList(myMediaManager.mediaPosition);
		
		
		JPanel pnl;
		mediaRight.add(medLab,BorderLayout.NORTH);
		
		Box vBox = Box.createVerticalBox();
		pnl = new JPanel();
		pnl.setLayout(new FlowLayout());
		pnl.add(filList);
		vBox.add(pnl);
		JButton delFile = new JButton("Delete Media");
		pnl = new JPanel();
		pnl.setLayout(new FlowLayout());
		pnl.add(delFile);
		vBox.add(pnl);
		JButton setFile = new JButton("new File");
		vBox.add(Box.createVerticalStrut(5));
		pnl = new JPanel();
		pnl.setLayout(new FlowLayout());
		pnl.add(mPos);
		pnl.add(setFile);
		vBox.add(pnl);
		vBox.add(Box.createVerticalStrut(5));
		pnl = new JPanel();
		pnl.setLayout(new FlowLayout());
		pnl.add(mDesc);
		vBox.add(pnl);
		vBox.add(Box.createVerticalStrut(5));
		pnl = new JPanel();
		pnl.setLayout(new FlowLayout());
		pnl.add(mTitle);
		vBox.add(pnl);
		
		JButton addMedia = new JButton("Add Media");
		
		
		delFile.addActionListener(
		new ActionListener()
		{
			
			public void actionPerformed(ActionEvent arg0) {
				try{
				DatabaseManager.dataMan.deleteMedia((String)filList.getSelectedValue());
				myMediaManager.delMedia(filList.getSelectedIndex());
				filList.updateUI();
				
				JOptionPane.showMessageDialog(null,"Deleted Successfully");
				}
				catch(SQLException e)
				{
					JOptionPane.showMessageDialog(null,"Sorry, Deletion Failed");
					e.printStackTrace();
				}
				catch(Exception e)
				{
					
				}
			
			}
			
		}
		);
		
		addMedia.addActionListener(
		new ActionListener()
		{
			/* (non-Javadoc)
			 * @see java.awt.event.ActionListener#actionPerformed(java.awt.event.ActionEvent)
			 */
			public void actionPerformed(ActionEvent arg0) {
				try
				{
					DatabaseManager.dataMan.insertMedia( mTitle.getText(), ServerInterface.this.mPos.getText(),ServerInterface.this.mDesc.getText());
					
					myMediaManager.addMedia(mTitle.getText(),mPos.getText(),mDesc.getText());
					filList.updateUI();
					
					JOptionPane.showMessageDialog(null,"Media Inserted Successfully");
				}
				catch(SQLException e)
				{
					JOptionPane.showMessageDialog(null,"Can't Add Media");
					e.printStackTrace();
				}
				

			}
		}
		);
		
		setFile.addActionListener(
		new ActionListener()
		{
			/* (non-Javadoc)
			 * @see java.awt.event.ActionListener#actionPerformed(java.awt.event.ActionEvent)
			 */
			public void actionPerformed(ActionEvent arg0) {
				try{
				JFileChooser x = new JFileChooser();
				x.showOpenDialog(null);
				ServerInterface.this.mPos.setText("file://"+x.getSelectedFile().getAbsolutePath());
				}
				catch(Exception e)
				{
					
				}

			}
		}
		);
		vBox.add(addMedia);
		
		mediaRight.add(vBox);
		filList.addMouseListener(
		new MouseAdapter()
		{
		/* (non-Javadoc)
		 * @see java.awt.event.MouseAdapter#mouseClicked(java.awt.event.MouseEvent)
		 */
		public void mouseClicked(MouseEvent arg0) {
			
			super.mouseClicked(arg0);
			int p = ServerInterface.this.filList.getSelectedIndex();
			ServerInterface.this.mTitle.setText((String)ServerInterface.this.myMediaManager.title.get(p)); 
			ServerInterface.this.mDesc.setText((String)ServerInterface.this.myMediaManager.description.get(p));
			ServerInterface.this.mPos.setText((String)ServerInterface.this.myMediaManager.mediaPosition.get(p));
		}
		}
		);
		
		mediaPanel.add(mediaLeft,BorderLayout.WEST);
		mediaPanel.add(mediaRight,BorderLayout.EAST);
		
		
		JTabbedPane jt = new JTabbedPane();
		jt.addTab("Server Management",pnlControl);
		jt.addTab("Client Management",leftPanel);
		jt.addTab("Server Traffic",midPanel);
		
		jt.addTab("Media Management",mediaPanel);
		
		container.add(jt,BorderLayout.CENTER);

		//set up server

		myVideoServer= new Server();
		
		myVideoServer.setServerEventHandler(this);
		
		
		btnStart.setEnabled(true);
		btnStop.setEnabled(false);
		btnStop.addActionListener(
				new ActionListener()
				{
					
					public void actionPerformed(ActionEvent arg0) {
						
						myVideoServer.stopServer();
						

					}
				}
			);
		btnMediaStart.addActionListener(
				new ActionListener()
				{
					
					public void actionPerformed(ActionEvent arg0) {
						//ServerInterface.this.setEnabled(false);
						myMediaManager.setUpMedia();
						//ServerInterface.this.setEnabled(true);
						JOptionPane.showMessageDialog(ServerInterface.this,"Media Ready for Transmission");
						myVideoServer.setMediaManager(myMediaManager);
						btnMediaStart.setEnabled(false);
						

					}
				}
		
		);
		//exit button Listener
		btnExit.addActionListener(
			new ActionListener()
			{
				
				public void actionPerformed(ActionEvent arg0) {
					
					closeProgram();
					

				}
			}
		);
		btnPing.addActionListener(
		new ActionListener()
		{
			
			public void actionPerformed(ActionEvent arg0) {
				
				JOptionPane.showMessageDialog(null,DatabaseManager.dataMan.searchPass("popel"));
			
				

			}
		}
		);
				
		setSize(700,500);
		setResizable(false);
		setLocation(162,134);
		
		setVisible(true);	
		
		//add window closing Listener
		
		this.addWindowListener(
			new WindowAdapter()
			{
				
				public void windowClosed(WindowEvent arg0) {
					
					super.windowClosed(arg0);
					
					System.exit(0); // exit
				}
				
			}
			);
		
		//btnStart
		btnStart.addActionListener(
		new ActionListener()
		{
			
			
			public void actionPerformed(ActionEvent arg0) {
					
				serverThread = new Thread(myVideoServer,"ServerThread");
				// TODO I commented this to fix a error with display update
				//serverThread.setPriority(Thread.NORM_PRIORITY+1);
				serverThread.start();
				
				
			}
		}
		);
		btnDisconnect.addActionListener(
		new ActionListener(){
			/* (non-Javadoc)
			 * @see java.awt.event.ActionListener#actionPerformed(java.awt.event.ActionEvent)
			 */
			public void actionPerformed(ActionEvent arg0) {
				myVideoServer.disconnectClient(1);

			}
		}
		);
		
		tblClients.setColumnSelectionAllowed(false);
		tblClients.setDragEnabled(false);
		tblClients.setSelectionForeground(Color.RED);
		
	}
	private void closeProgram()
	{
		
		System.exit(0);
	}
	
	public void serverStarts() {
		JOptionPane.showMessageDialog(this,"Server Started");
		btnStart.setEnabled(false);
		btnStop.setEnabled(true);
		System.out.println(Thread.currentThread().getName()+ " working about "+"");

	}
	
	public void serverStops() {
		btnStart.setEnabled(true);
		btnStop.setEnabled(false);
		JOptionPane.showMessageDialog(this,"Server stopped");
		System.out.println(Thread.currentThread().getName()+ " working about "+"");
		

	}
	//  TODO Client Messages should be Synchronized
	// TODO Because Many Clients send them
	// TODO Each ClientHandlers has a reference to the server Interface
	
	
	//public  void clientMessage(String s,String msg) {
	public synchronized void clientMessage(String s,String msg) {
		
		tLog.append(s+">>"+msg+"\n");
		System.out.println(Thread.currentThread().getName()+ " working about "+"");

	}


	//public void newClientConnected(String address) {
	public synchronized void newClientConnected(String address) {
		tLog.append("New Client Connected: "+address+"\n");
		lblHowMuchClients.setText(Integer.toString(myVideoServer.getConnetionNumber()) + " Clients Connected");
		System.out.println(Thread.currentThread().getName()+ " working about "+"");
		

	}

	//public  void clientDisconnected(String address) {
	public synchronized void clientDisconnected(int clientNumber) {
		
		
		lblHowMuchClients.setText(Integer.toString(myVideoServer.getConnetionNumber()) + " Clients Connected");
		try{
		int tbPos = ((Integer)hashTable.get(new Integer(clientNumber))).intValue();
		hashTable.remove(new Integer(clientNumber));
		System.out.println("Client Disconnected " + tbPos);
		vRow.removeElementAt(tbPos);
		tblClients.updateUI();
		tablePosition--;
		tLog.append("Disconnected "+ClientList.onlyList.getClientAt(clientNumber).getIpAddress()+"\n");
		}
		catch(Exception e)
		{
			
		}
		

		System.out.println(Thread.currentThread().getName()+ " working about "+"");
	}

	

	public synchronized void clientAuthorized(int clientNumber) {
		ClientInfo clientInfo = ClientList.onlyList.getClientAt(clientNumber);
		
		tLog.append(clientInfo.getIpAddress()+ " is authorized as "+clientInfo.getUserName()+"\n");
		Vector v =new Vector();
		v.add(clientInfo.getUserName());
		v.add(clientInfo.getIpAddress());
		v.add(new Integer(clientInfo.getCurrentActivity()));
		vRow.add(tablePosition,v);
		hashTable.put(new Integer(clientNumber),new Integer(tablePosition));
		tablePosition++;
		tblClients.updateUI();
		
		System.out.println(Thread.currentThread().getName()+ " working about "+"");

	}

	//public  void clientStateChanged(String address) {
	public synchronized void clientStateChanged(int	 clientNumber,int newAct) {
		// TODO Auto-generated method stub
		try{
			int tbPos = ((Integer)hashTable.get(new Integer(clientNumber))).intValue();
			((ClientInfo)vRow.get(tbPos)).setCurrentActivity(newAct);
			tblClients.updateUI();
			
			
			
			}
			catch(Exception e)
			{
				
			}
			

			System.out.println(Thread.currentThread().getName()+ " working about "+"");
	}

	public static void main(String[] args){
						try{
			//getting the current system look&feel

			UIManager.setLookAndFeel(UIManager.getSystemLookAndFeelClassName() );

		}
		catch(Exception ex){
			System.out.println("Look And Feel Exception");
		}

	
		ServerInterface serverGUI = new ServerInterface();
		serverGUI.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		System.out.println(Thread.currentThread().getName()+ " working about "+" main");
		
	}	
}